#include<bits/stdc++.h>
using namespace std;
int main()
{
    long long A, B, K;
    cin>>A>>B>>K;
    long long bad=((B+B%K)-(A+A%K))/K;
    long long nach=A;
    if(bad>0)
    {
        for(long long i=1; i<=bad; i++)
        {
            if((nach+bad*i-nach)%2==0)
            {
                A--;
            }
        }
    }
    cout<<(B-A)/2+(B-A)%2<<endl;
    return 0;
}
